from tkinter import *
import Sockets
from Sockets import *
from Position import Position
import dill as dill
from tkinter import ttk
from PIL import ImageTk, Image

root = Tk()
root.title("System")
root.geometry("850x700")
root.resizable(0, 0)

# Classes

server = Sockets.ThreadedServer(1, str(""), 1234)

server.start()

conn = ''

# Frames
input_frame = Frame(root, relief=RAISED, borderwidth=1)
input_frame.pack(side='left', expand=True, anchor='nw')

canvas_frame = Frame(root, relief=RAISED, borderwidth=1)
canvas_frame.pack(side='right', anchor='ne', ipady=10)

# Horizontal Canvas
h_backgroundCanvas = Canvas(canvas_frame, width=230, height=360, bg='white')
h_backgroundCanvas.grid(row=2, column=1, padx=50, pady=5)
h_canvas = Canvas(canvas_frame, width=200, height=330, bg='white')
h_canvas.grid(row=2, column=1, padx=10, pady=5)

# Vertical Canvas
v_backgroundCanvas = Canvas(canvas_frame, width=230, height=230, bg='white')
v_backgroundCanvas.grid(row=1, column=1, padx=50, pady=5)
v_canvas = Canvas(canvas_frame, width=200, height=200, bg='grey')
v_canvas.grid(row=1, column=1, padx=10, pady=5)
circleGrid = v_canvas.create_oval(1, 1, 202, 202, fill='white')

# Labels input
Label(input_frame, text="Type in Coordinates: ").grid(row=0, column=0, columnspan=2, padx=35)
Label(input_frame, text="Live stats/info").grid(row=0, column=4)
xLabel = Label(input_frame, text="x - ").grid(row=1, column=0, sticky='E')
yLabel = Label(input_frame, text="y - ").grid(row=2, column=0, sticky='E')
zLabel = Label(input_frame, text="z - ").grid(row=3, column=0, sticky='E')
depthLabel = Label(input_frame, text="Depth: ").grid(row=1, column=3)
currentLabel = Label(input_frame, text="Current: ").grid(row=2, column=3)
tempLabel = Label(input_frame, text="Temp: ").grid(row=3, column=3)
liveLabel = Label(input_frame, text="Live coordinates: ").grid(row=4, column=3)

# Labels fixed units
mLabel = Label(input_frame, text="moh")
mLabel.grid(row=1, column=5, padx=10)

msLabel = Label(input_frame, text="m/s")
msLabel.grid(row=2, column=5, padx=10)

cdegLabel = Label(input_frame, text='c' + u'\u00b0')
cdegLabel.grid(row=3, column=5, padx=10)

# x-coord entry box
xEntry = Entry(input_frame, width=10)
xEntry.grid(row=1, column=1, padx=10, pady=5, sticky='W')

# y-coord entry box
yEntry = Entry(input_frame, width=10)
yEntry.grid(row=2, column=1, padx=10, pady=5, sticky='W')

# z-coord entry box
zEntry = Entry(input_frame, width=10)
zEntry.grid(row=3, column=1, padx=10, pady=5, sticky='W')

# Depth output label
dOutput = Label(input_frame, text='0')
dOutput.grid(row=1, column=4, padx=10, pady=5)

# Current output label
sOutput = Label(input_frame, text='1.2')
sOutput.grid(row=2, column=4, padx=10, pady=5)

# Temp output label
tOutput = Label(input_frame, text='6')
tOutput.grid(row=3, column=4, padx=10, pady=5)


# Create balls
hBall = h_canvas.create_oval(95, 102.5, 105, 112.5, fill='red', tag='Ball')
vBall = v_canvas.create_oval(95, 95, 105, 105, fill='red', tag='Ball')

# Create arrows
hArrowX = h_backgroundCanvas.create_line(8, 355, 220, 355, arrow=LAST, width=3)
h_backgroundCanvas.create_text(225, 355, font="Times 14 italic bold", text="x")

hArrowY = h_backgroundCanvas.create_line(8, 355, 8, 15, arrow=LAST, width=3)
h_backgroundCanvas.create_text(8, 8, font="Times 14 italic bold", text="z")

vArrowX = v_backgroundCanvas.create_line(8, 225, 220, 225, arrow=LAST, width=3)
v_backgroundCanvas.create_text(225, 225, font="Times 14 italic bold", text="x")

vArrowZ = v_backgroundCanvas.create_line(8, 225, 8, 15, arrow=LAST, width=3)
v_backgroundCanvas.create_text(8, 8, font="Times 14 italic bold", text="y")

# Live label
lLabel = Label(input_frame, text="(0" + " , " + "0" + " , " + "0)")
lLabel.grid(row=4, column=4, pady=5, columnspan=2)

start_pos = None

xCoord = 105
yCoord = 105
zCoord = 162.5


# Functions


# Function for moving the balls
def move(event):
    global start_pos
    global xCoord
    global zCoord
    global yCoord
    global vBall
    global hBall

    if "Ball" in h_canvas.gettags(CURRENT):
        # Current[0] is x1 coord
        # Current[2] is x2 coord
        x1 = h_canvas.coords(CURRENT)[0]
        x2 = h_canvas.coords(CURRENT)[2]
        h_canvas.coords(CURRENT, x1, event.y - 5, x2, event.y + 5)

        if h_canvas.coords(CURRENT)[3] < 15:
            h_canvas.coords(CURRENT, x1, 5, x2, 15)
        elif h_canvas.coords(CURRENT)[3] > 325:
            h_canvas.coords(CURRENT, x1, 315, x2, 325)
        # z
        zCoord = h_canvas.coords(hBall)[3]

    if "Ball" in v_canvas.gettags(CURRENT):

        # Here event.x = x-coordinate, event.y = z-coordinate
        x = event.x
        y = event.y
        v_canvas.coords(CURRENT, x - 5, y - 5, x + 5, y + 5)

        if v_canvas.coords(CURRENT)[3] < 15:
            v_canvas.coords(CURRENT, x - 5, 5, x + 5, 15)

        elif v_canvas.coords(CURRENT)[3] > 200:
            v_canvas.coords(CURRENT, x - 5, 190, x + 5, 200)

        if v_canvas.coords(CURRENT)[2] < 15:
            v_canvas.coords(CURRENT, 5, y - 5, 15, y + 5)

        elif v_canvas.coords(CURRENT)[2] > 200:
            v_canvas.coords(CURRENT, 190, y - 5, 200, y + 5)

        xCoord = v_canvas.coords(vBall)[2]
        yCoord = v_canvas.coords(vBall)[3]

    update_labels()


# Function that updates the coordinates of the balls when you release mouse button 1
def update_balls(event):
    if "Ball" in h_canvas.gettags(CURRENT) or "Ball" in v_canvas.gettags(CURRENT):
        h_canvas.delete('Ball')
        v_canvas.delete('Ball')
        global xCoord
        global zCoord
        global yCoord
        global lLabel
        global vBall
        global hBall
        global xEntry
        global zEntry
        global yEntry
        lLabel.destroy()
        xEntry.delete(0, 'end')
        xEntry.insert(0, xCoord)
        yEntry.delete(0, 'end')
        yEntry.insert(0, yCoord)
        zEntry.delete(0, 'end')
        zEntry.insert(0, zCoord)

        xCoord = getdouble(xEntry.get())
        zCoord = getdouble(zEntry.get())
        yCoord = getdouble(yEntry.get())

        # Stop the ball from going out of bounds
        if xCoord > 375:
            xCoord = 375
            xEntry.delete(0, 'end')
            xEntry.insert(0, xCoord)
        elif xCoord <= 15:
            xCoord = 15
            xEntry.delete(0, 'end')
            xEntry.insert(0, xCoord)

        if yCoord > 200:
            yCoord = 200
            yEntry.delete(0, 'end')
            yEntry.insert(0, yCoord)
        elif yCoord <= 15:
            yCoord = 15
            yEntry.delete(0, 'end')
            yEntry.insert(0, yCoord)

        if zCoord > 325:
            zCoord = 325
            zEntry.delete(0, 'end')
            zEntry.insert(0, zCoord)
        elif zCoord <= 15:
            zCoord = 15
            zEntry.delete(0, 'end')
            zEntry.insert(0, zCoord)

        # Live output label

        lLabel = Label(input_frame, text="(" + str(xCoord) + " , " + str(yCoord) + " , " + str(zCoord) + ")")
        lLabel.grid(row=4, column=4, pady=5, columnspan=2)

        hBall = h_canvas.create_oval(xCoord - 10, zCoord - 10, xCoord, zCoord, fill='red', tag='Ball')
        vBall = v_canvas.create_oval(xCoord - 10, yCoord - 10, xCoord, yCoord, fill='red', tag='Ball')

        print("(" + str(round(xCoord*2.78)) + " , "
              + str(round(yCoord*2.78)) + " , "
              + str(round(zCoord*2)) + ")")


def update_labels():
    global xCoord
    global zCoord
    global yCoord
    global lLabel
    lLabel.config(text="(" + str(xCoord) + " , "
                       + str(yCoord) + " , "
                       + str(zCoord) + ")")
    dOutput.config(text=round(-50 + (325 - zCoord) / 6.5, 2))


def go_to():
    h_canvas.delete('Ball')
    v_canvas.delete('Ball')
    global xCoord
    global zCoord
    global yCoord
    global lLabel
    global vBall
    global hBall
    global xEntry
    global zEntry
    global yEntry
    lLabel.destroy()

    xCoord = getdouble(xEntry.get())
    yCoord = getdouble(yEntry.get())
    zCoord = getdouble(zEntry.get())

    if xCoord > 200:
        xCoord = 200
        xEntry.delete(0, 'end')
        xEntry.insert(0, xCoord)
    elif xCoord <= 15:
        xCoord = 15
        xEntry.delete(0, 'end')
        xEntry.insert(0, xCoord)

    if yCoord > 200:
        yCoord = 200
        yEntry.delete(0, 'end')
        yEntry.insert(0, yCoord)
    elif yCoord <= 15:
        yCoord = 15
        yEntry.delete(0, 'end')
        yEntry.insert(0, yCoord)

    if zCoord > 325:
        zCoord = 325
        zEntry.delete(0, 'end')
        zEntry.insert(0, zCoord)
    elif zCoord <= 15:
        zCoord = 15
        zEntry.delete(0, 'end')
        zEntry.insert(0, zCoord)

    lLabel = Label(input_frame, text="(" + str(xCoord) + " , " + str(yCoord) + " , " + str(zCoord) + ")")
    lLabel.grid(row=4, column=4, pady=5, columnspan=2)
    hBall = h_canvas.create_oval(xCoord - 10, zCoord - 10, xCoord, zCoord, fill='red', tag='Ball')
    vBall = v_canvas.create_oval(xCoord - 10, yCoord - 10, xCoord, yCoord, fill='red', tag='Ball')

    send()


def send():
    global xCoord
    global yCoord
    global zCoord
    x = round(xCoord * 2.78)
    y = round(yCoord * 2.78)
    z = round(zCoord * 2)

    if x > 380:
        x = 380
    elif x < 195:
        x = 195

    if y > 380:
        y = 380
    elif y < 195:
        y = 195

    if z > 600:
        z = 600
    elif z < 100:
        z = 100

    print("(" + str(round(x)) + " , "
          + str(round(y)) + " , "
          + str(round(z)) + ")")

    pos = Position(x, y, z)
    d = dill.dumps(pos)
    server.send_pos(d)


def nullstill():
    global xEntry
    global yEntry
    global zEntry

    xEntry.delete(0, 'end')
    xEntry.insert(0, 105)

    yEntry.delete(0, 'end')
    yEntry.insert(0, 105)

    zEntry.delete(0, 'end')
    zEntry.insert(0, 162.5)


# Buttons
btnStart = Button(input_frame, text="Go to posistion", command=go_to).grid(row=5, column=1, sticky='W', pady=50)
btnExit = Button(input_frame, text="Exit", command=root.quit).grid(row=5, column=4, ipadx=10)
btnNullstill = Button(input_frame, text="Nullstill", command=nullstill).grid(row=5, column=2, sticky='W', pady=50)

root.bind('<B1-Motion>', move)
root.bind('<ButtonRelease-1>', update_balls)

root.mainloop()
