import setassemblylength
import variables as v
import math


class MoveToPosition:

    __circle_radius = v.circle_radius
    __x = __circle_radius
    __y = __circle_radius
    __z = v.z_start_depth
    __position = [__x, __y, __z]
    __coordA = [__circle_radius, __circle_radius * 2]
    __coordB = [(__circle_radius - (math.sqrt(3) / 2) * __circle_radius), __circle_radius / 2]
    __coordC = [(__circle_radius + (math.sqrt(3) / 2) * __circle_radius), __circle_radius / 2]

    __assemblyA = setassemblylength.SetAssemblyLength(v.aSensorAPin, v.aSensorBPin, v.aMotorAPin, v.aMotorBPin, "a")

    __assemblyB = setassemblylength.SetAssemblyLength(v.bSensorAPin, v.bSensorBPin, v.bMotorAPin, v.bMotorBPin, "b")

    __assemblyC = setassemblylength.SetAssemblyLength(v.cSensorAPin, v.cSensorBPin, v.cMotorAPin, v.cMotorBPin, "c")

    __assemblyA.start()
    __assemblyB.start()
    __assemblyC.start()

    def __coordinate_to_length(self, assembly, coordinate):
        d = (math.pow(coordinate[0] - assembly[0], 2) + math.pow(coordinate[1] - assembly[1], 2))
        length = math.sqrt(d + math.pow(coordinate[2], 2))
        # print(length)
        return length

    def move_to_position(self, pos):

        npos = [pos[0], pos[1], pos[2]]
        self.__assemblyA.new_length(self.__coordinate_to_length(self.__coordA, npos))
        self.__assemblyB.new_length(self.__coordinate_to_length(self.__coordB, npos))
        self.__assemblyC.new_length(self.__coordinate_to_length(self.__coordC, npos))
